﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.ComponentModel;

namespace VSS2XGUI
{
    public partial class CColumnProperty : System.ComponentModel.INotifyPropertyChanged, ICloneable
    {
        protected string mDisplayName = "";         // Name to ge shown in the header
        protected string mColumnName = "";          // Name of the column as used in the database
        protected bool mIsVisible = true;           // 
        protected bool mIsReadOnly = false;         // 
        protected bool mHasChanged = false;         // 
        protected int mDetailFieldNum = 0;          // Number 1 - 6: The field is shown in the detail field 
        protected bool mIsScrollTipField = false;   // The field is shown while scrolling


        public CColumnProperty(string columnName, string displayName)
        {
            mColumnName = columnName;
            mDisplayName = displayName;
            mIsVisible = true;
            mIsReadOnly = false;
            mDetailFieldNum = 0;
        }

        public CColumnProperty(string columnName, string displayName, bool isVisible, bool isReadOnly)
        {
            mColumnName = columnName;
            mDisplayName = displayName;
            mIsVisible = isVisible;
            mIsReadOnly = isReadOnly;
        }

        public CColumnProperty(string columnName, string displayName, bool isVisible, bool isReadOnly, int DetailFieldNum, bool IsScrollTipField)
        {
            mColumnName = columnName;
            mDisplayName = displayName;
            mIsVisible = isVisible;
            mIsReadOnly = isReadOnly;
            mDetailFieldNum = DetailFieldNum;
            mIsScrollTipField = IsScrollTipField;
        }

        public bool IsVisible
        {
            set 
            { 
                mIsVisible = value;
                OnPropertyChange("IsVisible");
            }
            get { return mIsVisible; }
        }

        public bool IsScrollTipField
        {
            set { mIsScrollTipField = value; }
            get { return mIsScrollTipField; }
        }

        public int DetailFieldNumber
        {
            set { mDetailFieldNum = value; }
            get { return mDetailFieldNum; }
        }

        public string DisplayName
        {
            set 
            { 
                mDisplayName = value;
                OnPropertyChange("DisplayName");
            }
            get { return mDisplayName; }
        }

        public string ColumnName
        {
            set 
            { 
                mColumnName = value;
                OnPropertyChange("ColumnName");
            }
            get { return mColumnName; }
        }

        public bool IsReadOnly
        {
            set 
            { 
                mIsReadOnly = value;
                OnPropertyChange("ColumnName");                
            }
            get { return mIsReadOnly; }
        }

        public override string ToString()
        {
            return  DisplayName + 
                    " (ColumnName = " + ColumnName + 
                    ", IsVisible = " + mIsVisible.ToString() + 
                    ", IsReadOnly = " + IsReadOnly.ToString() + 
                    ")";
        }


        #region INotifyPropertyChanged members
        public event PropertyChangedEventHandler PropertyChanged;

        private void OnPropertyChange(string propertyName)
        {
            mHasChanged = true;
            if(this.PropertyChanged != null)
                this.PropertyChanged(this, new System.ComponentModel.PropertyChangedEventArgs(propertyName));
        }
        #endregion

        #region ICloneable Members

        public object Clone()
        {

            CColumnProperty clone;

            clone = new CColumnProperty(this.ColumnName, this.DisplayName, this.IsVisible, this.IsReadOnly);

            return clone;
        }

        #endregion

  
    }
}
